#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>

typedef long long llong;
const int MAXNUM = 1000 + 10;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int a[MAXN], n;
int cnt[MAXNUM];

int alike(int x, int y)
{
    int ans = 0;
    while (x > 0 && y > 0)
    {
        ans += ((x % 10) == (y % 10));
        x /= 10;
        y /= 10;
    }

    return ans;
}

void solve()
{
    int max = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        cnt[a[i]]++;
        max = std::max(max, a[i]);
    }

    llong ans = 0;
    for (int i = 1 ; i <= max ; ++i)
    {
        ans += 1LL * alike(i, i) * cnt[i] * (cnt[i] - 1) / 2; 
        for (int j = i + 1 ; j <= max ; ++j)
        {
            ans += 1LL * alike(i, j) * cnt[i] * cnt[j];
        }
    }

    std::cout << ans << '\n';
}

void read()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }   
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    read();
    solve();

    return 0;
}