#include <algorithm>
#include <iostream>
#include <numeric>
#include <fstream>
#include <cstdlib>
#include <vector>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n;
int minN;
int maxN;
int cntBig;
int chance;
int maxNum;
int a[MAXN];
std::vector <int> digs[9];

inline int getDigits(int num)
{
    int cnt = 0;
    while (num > 0)
    {
        cnt++;
        num /= 10;
    }

    return cnt;
}

int pickDigit(int digit)
{
    int rnd = rand()%1000;
    for (int i = 0 ; i < cntBig ; ++i)
    {
        if (i * chance <= rnd && rnd < (i + 1) * chance) return digs[digit][i];
    }

    rnd = rand()%(10 - cntBig);
    return digs[digit][cntBig + rnd];
}

int main(int argc, char **argv)
{
    srand(time(nullptr));
    std::ifstream fin("constraints.txt");
    std::ofstream fout(argv[1]);
    fin >> minN >> maxN >> maxNum >> cntBig >> chance; 
    n = rand()%(maxN - minN + 1) + minN;
    for (int i = 0 ; i < 9 ; ++i)
    {
        digs[i].resize(10);
        std::iota(digs[i].begin(), digs[i].end(), 0);
        std::random_shuffle(digs[i].begin(), digs[i].end());
    }

    fout << n << '\n';
    for (int i = 1 ; i <= n ; ++i)
    {
        int num = rand()%(int)(maxNum - 1) + 1;
        int len = getDigits(num);
        int currDigit;
        int curr = 0;

        do
        {
            currDigit = pickDigit(len - 1);
            if (currDigit != 0) break;
        } while(true);

        curr = currDigit;
        for (int j = len - 2 ; j >= 0 ; --j)
        {
            curr *= 10;
            curr += pickDigit(j);
        }

        fout << curr;
        if (i != n) fout << ' ';
    }

    fout << '\n';
    fout.close();
    fin.close();
    return 0;
}